import Data.Yaml
import Data.Text

data Var = Var {
  v' :: Either MyList Item
  } deriving Show

data MyList = MyList {
  a' :: Int,
  b' :: Int
  } deriving Show

data Item = Item {
  content' :: String
  } deriving Show

instance FromJSON Var where
  parseJSON (Object m) = Var <$> m .: (pack "v")

instance FromJSON MyList where
  parseJSON (Object m) = MyList <$> m .: (pack "a") <*> m .: (pack "b")
  parseJSON  x = fail ("not an object: " ++ show x)

instance FromJSON Item where
  parseJSON (Object m) = Item <$> m .: (pack "c")
  parseJSON x = fail ("not an object: " ++ show x)

readItem :: IO Item
readItem = either (error.show) id <$> decodeFileEither "test.yaml"

readMyList :: IO MyList
readMyList = either (error.show) id <$> decodeFileEither "test.yaml"

readVar :: IO Var
readVar = either (error.show) id <$> decodeFileEither "test.yaml"

main = readVar
